<?php
    /*
      Plugin Name: Questionarie Tool
      Plugin URI: https://technology-architects.com
      Description: Plugin to create Multiple Questionarie 
      Version: 1.0
      Author: Technology Architects
      Author URI: https://www.facebook.com/javaid.ahmad.142
      License: GPLv2+
      Text Domain: wp-analytify-simple
    */
    define( 'PLUGIN_NAME_VERSION', '1.0.0' );
    /*********** Plugin Activation *********************/
    function activate_questionarie_plugin(){
        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();
        /* Creating Survey Table */
        $table_name = $wpdb->prefix . 'questionarie_surveys';
        $sql = "CREATE TABLE $table_name (
                id mediumint(9) NOT NULL AUTO_INCREMENT,
                name varchar(255) NOT NULL,
                description text NOT NULL,
                contact_question_text text NOT NULL,
		question_per_page mediumint(9) NOT NULL,
                UNIQUE KEY id (id) 
        ) $charset_collate;";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );
        /* End Creating Survey Table */

        /* Creating Questions Table */
        $table_name = $wpdb->prefix . 'questionarie_questions';

        $sql = "CREATE TABLE $table_name (
                id mediumint(9) NOT NULL AUTO_INCREMENT,
                survey_id mediumint(9) NOT NULL,
                Question text NOT NULL,
                Question_type varchar(255) NOT NULL,
                category mediumint(9) NOT NULL,
                UNIQUE KEY id (id)
        ) $charset_collate;";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );
        /* End Creating Question Table */

        /* Creating Categories Table */
        $table_name = $wpdb->prefix . 'questionarie_categories';

        $sql = "CREATE TABLE $table_name (
                id mediumint(9) NOT NULL AUTO_INCREMENT,
                name varchar(255) NOT NULL,
                description text NOT NULL, 
                UNIQUE KEY id (id)
        ) $charset_collate;";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );
        /* End Creating Categories Table */

        /* Creating Question options Table */
        $table_name = $wpdb->prefix . 'questionarie_question_options';

        $sql = "CREATE TABLE $table_name (
                id mediumint(9) NOT NULL AUTO_INCREMENT,
                question_id mediumint(9) NOT NULL,
                option_text varchar(255) NOT NULL,
                points mediumint(9) NOT NULL, 
                UNIQUE KEY id (id)
        ) $charset_collate;"; 

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );
        /* End Question options Table */

        $table_name = $wpdb->prefix . 'questionarie_page';

        $sql = "CREATE TABLE $table_name (
                page_id mediumint(9) NOT NULL,
                pdf_page_id mediumint(9) NOT NULL
        ) $charset_collate;"; 

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta($sql);


        /************ Table of saving Survey Attempted ***********/

        /* Creating Attempted Survey Table */
        $table_name = $wpdb->prefix . 'questionarie_attempted_survey'; 

        $sql = "CREATE TABLE $table_name (
                id mediumint(9) NOT NULL AUTO_INCREMENT,
                survey_id mediumint(9) NOT NULL,
                name varchar(255) NOT NULL,
                email varchar(255) NOT NULL,
                company varchar(255) NOT NULL,
                phone varchar(255) NOT NULL,
                contact varchar(255) NOT NULL,
                UNIQUE KEY id (id)
        ) $charset_collate;"; 

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );

        /* End Attempted survey Table */

        /* Creating Attempted Survey Detail  */
        $table_name = $wpdb->prefix . 'questionarie_attempted_survey_details'; 

        $sql = "CREATE TABLE $table_name (
                id mediumint(9) NOT NULL AUTO_INCREMENT,
                survey_id mediumint(9) NOT NULL,
                question varchar(255) NOT NULL,
                anwer_text varchar(255) NOT NULL,
                points varchar(255) NOT NULL,
                cat mediumint(9) NOT NULL,
                UNIQUE KEY id (id)
        ) $charset_collate;";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );

        /* End Attempted survey Detail Table */

        /* Creating category Scoring details  */
        $table_name = $wpdb->prefix . 'questionarie_category_score_details'; 

        $sql = "CREATE TABLE $table_name (
                id mediumint(9) NOT NULL AUTO_INCREMENT,
                cat_id mediumint(9) NOT NULL,
                range_0_20 varchar(255) NOT NULL,
                range_20_40 varchar(255) NOT NULL,
                range_40_60 varchar(255) NOT NULL,
                range_60_80 varchar(255) NOT NULL,
                range_80_100 varchar(255) NOT NULL,
                UNIQUE KEY id (id)
        ) $charset_collate;";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        dbDelta( $sql );

        /* End Attempted category Scoring details */


        /********************* Creating a page for survey ************************/

        $post = array('post_title'     => 'questionarrie-survey',                  
                      'post_status'    =>  'publish', 
                      'post_type'      =>  'page');

        $post_id = wp_insert_post($post);
        update_post_meta($post_id, "_wp_page_template", "/survey.php"); 
        $plugin_dir = plugin_dir_path( __FILE__ ) . 'survey.php';
        $theme_dir = get_stylesheet_directory() . '/survey.php'; 
        if(!copy($plugin_dir, $theme_dir)){
            echo "failed to copy $plugin_dir to $theme_dir...\n";
        }
        
        $table_name = $wpdb->prefix .'questionarie_page';
        $wpdb->query("INSERT INTO ".$table_name."(`page_id`) VALUES ('".$post_id."')");
        /****************** End of page for survey ************************/
        
        /********************* Creating a page for survey ************************/

        $post = array('post_title'     => 'survey-pdf',                  
                      'post_status'    =>  'publish', 
                      'post_type'      =>  'page');

        $post_id = wp_insert_post($post);
        update_post_meta($post_id, "_wp_page_template", "/pdf.php"); 
        $plugin_dir = plugin_dir_path( __FILE__ ) . 'pdf.php';
        $theme_dir = get_stylesheet_directory() . '/pdf.php'; 
        if(!copy($plugin_dir, $theme_dir)){
            echo "failed to copy $plugin_dir to $theme_dir...\n";
        }
        
        $table_name = $wpdb->prefix .'questionarie_page';
        $wpdb->query("UPDATE $table_name SET pdf_page_id=".$post_id);
        /****************** End of page for survey ************************/
        
    }

    register_activation_hook( __FILE__, 'activate_questionarie_plugin' );

    function deactivate_questionarie_plugin() {
        global $wpdb;
        $theme_dir = get_stylesheet_directory() . '/survey.php';
        unlink($theme_dir);
        $theme_dir = get_stylesheet_directory() . '/pdf.php';
        unlink($theme_dir);
        $table_name = $wpdb->prefix .'questionarie_page';
        $result = $wpdb->get_results("SELECT * FROM $table_name");
        $page_id = $result[0]->page_id;
        wp_delete_post($page_id, true);
        $page_id = $result[0]->pdf_page_id;
        wp_delete_post($page_id, true);
        $wpdb->query("DROP TABLE IF EXISTS $table_name");
    }

    register_deactivation_hook( __FILE__, 'deactivate_questionarie_plugin');

    /*************** End Plugin Activation **********************/

    function wporg_options_page(){
        add_menu_page('questionarie','Questionarie','manage_options','Questionarie','questionarie');
        add_submenu_page('Questionarie', 'add_new_survey', 'Manage Surveys', 'manage_options', 'Add New Survey', 'add_new_survey', 'Questionarie');
        add_submenu_page(null, 'add_question', 'Add Question', 'manage_options', 'Add Question', 'add_question', 'Questionarie');
        add_submenu_page(null, 'edit_question', 'Edit Question', 'manage_options', 'Edit Question', 'edit_question', 'Questionarie');
        add_submenu_page(null, 'manage_question', 'Manage Question', 'manage_options', 'Manage Question', 'manage_question', 'Questionarie');
        add_submenu_page('Questionarie', 'categories', 'Categories', 'manage_options', 'Categories', 'categories', 'Questionarie');
        add_submenu_page('Questionarie', 'attempted_surveys', 'Attempted Surveys', 'manage_options', 'Attempted Surveys', 'attempted_surveys', 'Questionarie');
        add_submenu_page(null, 'survey_details', 'Survey Details', 'manage_options', 'Survey Details', 'survey_details', 'Questionarie');
        add_submenu_page(null, 'manage_score', 'Manage Score', 'manage_options', 'Manage Score', 'manage_score', 'Questionarie');
        add_submenu_page(null, 'contact_question', 'Contact Question', 'manage_options', 'Contact Question', 'contact_question', 'Questionarie');
    }

    add_action('admin_menu', 'wporg_options_page');
    require_once plugin_dir_path( __FILE__ ) . 'questionarie.php';
    require_once plugin_dir_path( __FILE__ ) . 'add_new_survey.php';
    require_once plugin_dir_path( __FILE__ ) . 'categories.php';
    require_once plugin_dir_path( __FILE__ ) . 'add_question.php';
    require_once plugin_dir_path( __FILE__ ) . 'edit_question.php';
    require_once plugin_dir_path( __FILE__ ) . 'attempted_surveys.php';
    require_once plugin_dir_path( __FILE__ ) . 'survey_details.php';
    require_once plugin_dir_path( __FILE__ ) . 'manage_question.php';
    require_once plugin_dir_path( __FILE__ ) . 'manage_score.php';
    require_once plugin_dir_path( __FILE__ ) . 'contact_question.php';

    add_action( 'admin_post_add_survey', 'prefix_admin_add_survey');
    add_action( 'admin_post_nopriv_add_survey', 'prefix_admin_add_survey');

    function prefix_admin_add_survey(){
        global $wpdb;
		$name = $_REQUEST['name'];
        $description = $_REQUEST['descripton'];
        $questi_page = $_REQUEST['question_per_page'];
		$wpdb->query("INSERT INTO ".$wpdb->prefix."questionarie_surveys (name, description, question_per_page) VALUES('".$name."','".$description."', '".$questi_page."')");
        wp_redirect(site_url()."/wp-admin/admin.php?page=Add+New+Survey");
    }

    add_action('admin_post_delete_survey', 'prefix_admin_delete_survey');
    add_action('admin_post_nopriv_delete_survey', 'prefix_admin_delete_survey');

    function prefix_admin_delete_survey(){
        $survey_id = $_REQUEST['survey_id'];
        global $wpdb;
        $wpdb->query("DELETE FROM ".$wpdb->prefix."questionarie_surveys WHERE id=".$survey_id);
        wp_redirect(site_url()."/wp-admin/admin.php?page=Add+New+Survey");
    }

    add_action('admin_post_edit_survey', 'prefix_admin_edit_survey');
    add_action('admin_post_nopriv_edit_survey', 'prefix_admin_edit_survey');

    function prefix_admin_edit_survey(){
        global $wpdb;
        $name = $_REQUEST['name'];
        $desc = $_REQUEST['descripton'];
        $q_page = $_REQUEST['question_per_page'];
        $id     = $_REQUEST['survey_id'];
        $wpdb->query("UPDATE ".$wpdb->prefix."questionarie_surveys SET name='".$name."', description='".$desc."', question_per_page='".$q_page."' WHERE id=".$id);
        wp_redirect(site_url()."/wp-admin/admin.php?page=Add+New+Survey&survey_id=".$id);
    }

    add_action('admin_post_add_question', 'prefix_admin_add_question');
    add_action('admin_post_nopriv_add_question', 'prefix_admin_add_question');
    
    function prefix_admin_add_question(){
        global $wpdb;
        $survey_id = $_REQUEST['survey_id'];
        $name = $_REQUEST['name'];
        $question_cat  = $_REQUEST['question_cat'];
        $question_type = $_REQUEST['question_type'];
        $wpdb->query("INSERT INTO ".$wpdb->prefix."questionarie_questions (survey_id, Question, Question_type, category) "
                                                                            . "VALUES('".$survey_id."', '".$name."', '".$question_type."', '".$question_cat."')");
        if($question_type != "text") {
            $lastid = $wpdb->insert_id;
            $option_text = $_REQUEST['option_text'];
            foreach($option_text as $key=>$value){
                $option = $value;
                $points = $_REQUEST['option_points'][$key];
                $wpdb->query("INSERT INTO ".$wpdb->prefix."questionarie_question_options (question_id, option_text, points) VALUES('".$lastid."', '".$option."', '".$points."')");
            }
        }
        wp_redirect(site_url()."/wp-admin/admin.php?page=Edit+Question&id='".$lastid."'&surveyid=".$survey_id);
    }

    add_action('admin_post_delete_question', 'prefix_admin_delete_question');
    add_action('admin_post_nopriv_delete_question', 'prefix_admin_delete_question');

    function prefix_admin_delete_question(){
        global $wpdb;
        $question_id = $_REQUEST['question_id'];
        $survey_id = $_REQUEST['survey_id'];
        $wpdb->query("DELETE FROM  ".$wpdb->prefix."questionarie_questions WHERE id=".$question_id);
        wp_redirect(site_url()."/wp-admin/admin.php?page=Manage+Question&id=".$survey_id);
    }

    add_action('admin_post_edit_question', 'prefix_admin_edit_question');
    add_action('admin_post_nopriv_edit_question', 'prefix_admin_edit_question');

    function prefix_admin_edit_question(){
        global $wpdb;
        $qu_id  = $_REQUEST['question_id'];
        $ques   = $_REQUEST['name'];
        $q_cat  = $_REQUEST['question_cat'];
        $q_type = $_REQUEST['question_type'];
        $wpdb->query("UPDATE ".$wpdb->prefix."questionarie_questions SET `Question`='".$ques."', `Question_type`='".$q_type."', `category` = '".$q_cat."' WHERE id=".$qu_id);
        $wpdb->query("DELETE FROM ".$wpdb->prefix."questionarie_question_options WHERE question_id=".$qu_id);
        if($q_type != "text") {
            $lastid = $qu_id;
            $option_text = $_REQUEST['option_text'];
            foreach($option_text as $key=>$value){
                $option = $value;
                $points = $_REQUEST['option_points'][$key];
                $wpdb->query("INSERT INTO ".$wpdb->prefix."questionarie_question_options (question_id, option_text, points) VALUES('".$lastid."', '".$option."', '".$points."')");
            }
        }
        wp_redirect(site_url()."/wp-admin/admin.php?page=Edit+Question&id=".$qu_id);
    }

    add_action('admin_post_add_category', 'prefix_admin_add_category');
    add_action('admin_post_nopriv_add_category', 'prefix_admin_add_category');

    function prefix_admin_add_category(){
        global $wpdb;
        $category   = $_REQUEST['name'];
        $descripton = $_REQUEST['descripton'];
        $wpdb->query("INSERT INTO ".$wpdb->prefix."questionarie_categories (name, description) VALUES ('".$category."', '".$descripton."')");
        wp_redirect(site_url()."/wp-admin/admin.php?page=Categories");
    }

    add_action('admin_post_delete_category', 'prefix_admin_delete_category');
    add_action('admin_post_nopriv_delete_category', 'prefix_admin_delete_category');

    function prefix_admin_delete_category(){
        global $wpdb;
        $cat_id = $_REQUEST['cat_id'];
        $wpdb->query("DELETE FROM ".$wpdb->prefix."questionarie_categories WHERE id=".$cat_id);
        wp_redirect(site_url()."/wp-admin/admin.php?page=Categories");
    }

    add_action('admin_post_edit_category', 'prefix_admin_edit_category');
    add_action('admin_post_nopriv_edit_category', 'prefix_admin_edit_category');

    function prefix_admin_edit_category(){
        global $wpdb;
        $name   = $_REQUEST['name'];
        $cat_id = $_REQUEST['cat_id'];
        $desc   = $_REQUEST['descripton'];
        $wpdb->query("UPDATE ".$wpdb->prefix."questionarie_categories SET `name`='".$name."', `description` = '".$desc."' WHERE id=".$cat_id);
        wp_redirect(site_url()."/wp-admin/admin.php?page=Categories&cat_id=".$cat_id);
    }

    add_action('admin_post_submit_survey', 'prefix_admin_submit_survey');
    add_action('admin_post_nopriv_submit_survey', 'prefix_admin_submit_survey');

    function prefix_admin_submit_survey(){
        global $wpdb;
        $survey_id = $_REQUEST['survey_id'];
        $name  = $_REQUEST['name'];
        $email = $_REQUEST['email'];
        $compn = $_REQUEST['company'];
        $phone = $_REQUEST['phone'];
        $conta = $_REQUEST['question_contact'];
        $wpdb->query("INSERT INTO ".$wpdb->prefix."questionarie_attempted_survey(survey_id, name, email, company, phone, contact) VALUES('".$survey_id."', '".$name."', '".$email."', '".$compn."', '".$phone."', '".$conta."')");
        $lastid = $wpdb->insert_id;
        $table_name = $wpdb->prefix .'questionarie_page';
        $result = $wpdb->get_results("SELECT * FROM $table_name");
        $page_id = $result[0]->page_id;
        $table_name = $wpdb->prefix . 'questionarie_questions';
        $survey_questions = $wpdb->get_results("SELECT * FROM $table_name WHERE survey_id=".$survey_id);

            foreach($survey_questions as $question){
                $question_id = $question->id;
                $question_text = $question->Question;
                $Questi_type   = $question->Question_type;
                $question_cat  = $question->category;
                    if($Questi_type == "text"){
                        $answer = $_POST["question_$question_id"];
                        $table_name = $wpdb->prefix . 'questionarie_attempted_survey_details';    
                        $wpdb->query("INSERT INTO $table_name(survey_id, question, anwer_text, cat) VALUES('".$lastid."', '".$question_text."', '".$answer."', '".$question_cat."')");
                    } else if($Questi_type == "single"){
                        $option_id = $_POST["question_$question_id"];
                        $table_name = $wpdb->prefix . 'questionarie_question_options';
                        $questionoption = $wpdb->get_results("SELECT * FROM $table_name WHERE id=".$option_id);
                        $option_text = $questionoption[0]->option_text;
                        $option_points = $questionoption[0]->points;
                        $table_name = $wpdb->prefix . 'questionarie_attempted_survey_details';    
                        $wpdb->query("INSERT INTO $table_name(survey_id, question, anwer_text, points, cat) VALUES('".$lastid."', '".$question_text."', '".$option_text."', '".$option_points."', '".$question_cat."')");
                    } else {
                        $option_text = "";
                        $option_points = "";
                        $ans = $_POST["question_$question_id"];
                            foreach($ans as $val) {
                                $table_name = $wpdb->prefix . 'questionarie_question_options';
                                $questionoption = $wpdb->get_results("SELECT * FROM $table_name WHERE id=".$val);
                                $option_text = $option_text.','.$questionoption[0]->option_text;
                                $option_points = $option_points .','.$questionoption[0]->points;

                            }
                        $option_text   = trim($option_text,",");
                        $option_points = trim($option_points,",");
                        $table_name = $wpdb->prefix . 'questionarie_attempted_survey_details';    
                        $wpdb->query("INSERT INTO $table_name(survey_id, question, anwer_text, points, cat) VALUES('".$lastid."', '".$question_text."', '".$option_text."', '".$option_points."', '".$question_cat."')");
                    }
            }
        $url = site_url()."/?page_id=".$page_id."&quiz_id=".$survey_id."&submit=".$lastid;
        header('Location: '.$url);
        die();
    }

    add_action('admin_post_update_cat_score', 'prefix_admin_update_cat_score');
    add_action('admin_post_nopriv_update_cat_score', 'prefix_admin_update_cat_score');

    function prefix_admin_update_cat_score(){
        global $wpdb;
        $range_0_20 = "";
        $range_20_40 = "";
        $range_40_60 = "";
        $range_60_80 = "";
        $range_80_100 = "";
        $cat_id = $_POST['cat_id'];
        $range_0_20   = $_POST['range_0_20'];
        $range_20_40  = $_POST['range_20_40'];
        $range_40_60  = $_POST['range_40_60'];
        $range_60_80  = $_POST['range_60_80'];
        $range_80_100 = $_POST['range_80_100'];
        $table_name = $wpdb->prefix . 'questionarie_category_score_details'; 
        $wpdb->query("DELETE FROM $table_name WHERE cat_id=".$cat_id);
        $wpdb->query("INSERT INTO $table_name(cat_id, range_0_20, range_20_40, range_40_60, range_60_80, range_80_100) VALUES('".$cat_id."', '".$range_0_20."', '".$range_20_40."', '".$range_40_60."','".$range_60_80."','".$range_80_100."')");
        $url = site_url()."/wp-admin/admin.php?page=Manage+Score&cat_id=".$cat_id;
        header('Location: '.$url);
        die();
    }

    add_action('admin_post_update_contact_question', 'prefix_admin_update_contact_question');
    add_action('admin_post_nopriv_update_contact_question', 'prefix_admin_update_contact_question');

    function prefix_admin_update_contact_question(){
        global $wpdb;
        $survey_id = $_POST['survey_id']; 
        $cquestion = $_POST['contact_question_text'];
        $cplacemen = $_POST['contact_question_place'];
        $table_name = $wpdb->prefix . 'questionarie_surveys';
        $wpdb->query("UPDATE $table_name SET contact_question_text ='".$cquestion."' WHERE id=".$survey_id);
        $url = site_url()."/wp-admin/admin.php?page=Contact+Question&survey_id=".$survey_id;
        header('Location: '.$url);
        die();
    }
    
    add_action('admin_post_delete_attempted_survey', 'prefix_admin_delete_attempted_survey');
    add_action('admin_post_nopriv_delete_attempted_survey', 'prefix_admin_delete_attempted_survey');

    function prefix_admin_delete_attempted_survey(){
        global $wpdb;
        $table_name = $wpdb->prefix . 'questionarie_attempted_survey';
        $survey_id = $_POST['survey_id'];
        $wpdb->query("DELETE FROM $table_name WHERE id=".$survey_id);
        $table_name = $wpdb->prefix . 'questionarie_attempted_survey_details';
        $wpdb->query("DELETE FROM $table_name WHERE survey_id=".$survey_id);
        $url = site_url()."/wp-admin/admin.php?page=Attempted+Surveys";
        header('Location: '.$url);
        die();
    }
    
?>